#include <iostream>
#include <utility>
#include <algorithm>
#include <boost/bind.hpp>
#include <boost/graph/graph_traits.hpp>
#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/breadth_first_search.hpp>

using namespace std;
using namespace boost;

class MyVisitor : public default_bfs_visitor {
public:
  template < typename Vertex, typename Graph >
    void discover_vertex(Vertex u, const Graph & g) const {
	  cout << "discover vertex:" << u << endl;
  }
};

int main() {
    typedef adjacency_list<vecS, vecS, directedS> Graph;     //typ grafu
    enum { A, B, C, D, N };               // identyfikatory wierzcholkow
    const int NUM_VERTICES = N;
    typedef std::pair<int, int> Edge;
    const Edge EDGE_ARRAY[] =             // krawedzie dla grafu
		{ Edge(A,B), Edge(A,D),
		  Edge(B,A), Edge(B,D),
		  Edge(C,B), Edge(D,C) };
    const int NUM_EDGES = sizeof(EDGE_ARRAY)/sizeof(EDGE_ARRAY[0]);
	//tworzy graf
    Graph g(EDGE_ARRAY, EDGE_ARRAY + NUM_EDGES, NUM_VERTICES);
	MyVisitor vis;
	breadth_first_search(g, A, visitor(vis) );
    return 0;
}
