#include <vector>
#include <algorithm>
#include <iostream>
#include <functional>

using namespace std;
using namespace std::placeholders;

void f(int x, int y) { cout << x + y << endl; }


struct F {
	F(int z = 0) : z_(z) {}
	void operator()(int x, int y){ cout << x + y + z_ << endl; }
	int z_;
};

struct Foo {
	Foo(int i = 0) : i_(i) {}
	void f(int x) {
		i_ += x;
		cout << "foo " << i_ << endl;
	}
	int i_;
};

int main() {
	function<void (int,int)> pf;
	pf=f;
	pf(2,3);
	pf = F();
	pf(2,3);
	pf = [](int x, int y){ cout << x  + y << endl; };
	pf(2,3);

	using PF = function<void (int)>;
	Foo x(3);
	PF px(bind(&Foo::f, ref(x), _1));

	vector<PF> callbacks;
 	callbacks.push_back( px );
 	callbacks.push_back( px );
 	callbacks.push_back( px );

 	for_each( callbacks.begin(), callbacks.end(), [](PF& pf){ pf(7); } );

	return 0;
}
